/*
 * Copyright (C) 2024 usbharu
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package dev.usbharu.hideout.activitypub.domain.model

import dev.usbharu.hideout.activitypub.domain.model.objects.Object

open class Emoji(
    type: List<String>,
    override val name: String,
    override val id: String,
    val updated: String,
    val icon: Image
) : Object(
    type = add(type, "Emoji")
),
    HasName,
    HasId {

    override fun toString(): String {
        return "Emoji(" +
            "name='$name', " +
            "id='$id', " +
            "updated='$updated', " +
            "icon=$icon" +
            ")" +
            " ${super.toString()}"
    }

    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (javaClass != other?.javaClass) return false
        if (!super.equals(other)) return false

        other as Emoji

        if (name != other.name) return false
        if (id != other.id) return false
        if (updated != other.updated) return false
        if (icon != other.icon) return false

        return true
    }

    override fun hashCode(): Int {
        var result = super.hashCode()
        result = 31 * result + name.hashCode()
        result = 31 * result + id.hashCode()
        result = 31 * result + updated.hashCode()
        result = 31 * result + icon.hashCode()
        return result
    }
}
